Chapter 4. Installing the NVIDIA Driver
Prev | Part I. Installation and Configuration Instructions | Next

## Chapter 4. Installing the NVIDIA Driver

This chapter provides instructions for installing the NVIDIA driver. Note that after installation, but prior to using the driver, you must complete the steps described in Chapter 6, Configuring X for the NVIDIA Driver. Additional details that may be helpful for the new Linux user are provided in Appendix I, Tips for New Linux Users.

## Before you Begin

Before you begin the installation, exit the X server and terminate all OpenGL applications (note that it is possible that some OpenGL applications persist even after the X server has stopped). You should also set the default run level on your system such that it will boot to a VGA console, and not directly to X. Doing so will make it easier to recover if there is a problem during the installation process. See Appendix I, Tips for New Linux Users for details.

If you're installing on a system that is set up to use the Nouveau driver, then you should first disable it before attempting to install the NVIDIA driver. See Q & A 8.1, “Interaction with the Nouveau Driver” for details.

## Starting the Installer

After you have downloaded the file `NVIDIA-Linux-x86_64-310.19.run`, change to the directory containing the downloaded file, and as the `root` user run the executable:

        # cd yourdirectory
        # sh NVIDIA-Linux-x86_64-310.19.run

The `.run` file is a self-extracting archive. When executed, it extracts the contents of the archive and runs the contained `nvidia-installer` utility, which provides an interactive interface to walk you through the installation.

`nvidia-installer` will also install itself to `/usr/bin/nvidia-installer`, which may be used at some later time to uninstall drivers, auto-download updated drivers, etc. The use of this utility is detailed later in this chapter.

You may also supply command line options to the `.run` file. Some of the more common options are listed below.

Common `.run` Options

`--info`

  Print embedded info about the `.run` file and exit.

`--check`

  Check integrity of the archive and exit.

`--extract-only`

  Extract the contents of `./NVIDIA-Linux-x86_64-310.19.run`, but do not run `nvidia-installer`.

`--help`

  Print usage information for the common commandline options and exit.

`--advanced-options`

  Print usage information for common command line options as well as the advanced options, and then exit.

## Installing the Kernel Interface

The NVIDIA kernel module has a kernel interface layer that must be compiled specifically for each kernel. NVIDIA distributes the source code to this kernel interface layer.

When the installer is run, it will check your system for the required kernel sources and compile the kernel interface. You must have the source code for your kernel installed for compilation to work. On most systems, this means that you will need to locate and install the correct kernel-source, kernel-headers, or kernel-devel package; on some distributions, no additional packages are required.

After the correct kernel interface has been compiled, the kernel interface will be linked with the closed-source portion of the NVIDIA kernel module. This requires that you have a linker installed on your system. The linker, usually `/usr/bin/ld`, is part of the binutils package. You must have a linker installed prior to installing the NVIDIA driver.

The installer will check for the presence of DKMS on your system. If DKMS is found, you will be given the option of registering the kernel module with DKMS, and using the DKMS infrastructure to build and install the kernel module. On most systems with DKMS, DKMS will take care of automatically rebuilding registered kernel modules when installing a different Linux kernel.

Not all kernel configurations are supported by DKMS: for example, DKMS does not support kernels built with separate KBUILD source and output directories. If `nvidia-installer` is unable to install the kernel module through DKMS, the installation will be aborted and no kernel module will be installed. If this happens, installation should be attempted again, without the DKMS option.

Note that versions of `nvidia-installer` shipped with drivers before release 304 do not interact with DKMS. If you choose to register the NVIDIA kernel module with DKMS, please ensure that the module is removed from the DKMS database before using a non-DKMS aware version of `nvidia-installer` to install an older driver; otherwise, module source files may be deleted without first unregistering the module, potentially leaving the DKMS database in an inconsistent state. Running `nvidia-uninstall` before installing a driver using an older installer will invoke the correct `dkms remove` command to clean up the installation.

## Features of the Installer

Without options, the `.run` file executes the installer after unpacking it. The installer can be run as a separate step in the process, or can be run at a later time to get updates, etc. Some of the more important commandline options of `nvidia-installer` are:

`nvidia-installer` options

`--uninstall`

  During installation, the installer will make backups of any conflicting files and record the installation of new files. The uninstall option undoes an install, restoring the system to its pre-install state.

`--latest`

  Connect to NVIDIA's FTP site, and report the latest driver version and the url to the latest driver file.

`--update`

  Connect to NVIDIA's FTP site, download the most recent driver file, and install it.

`--ui=none`

  The installer uses an ncurses-based user interface if it is able to locate the correct ncurses library. Otherwise, it will fall back to a simple commandline user interface. This option disables the use of the ncurses library.

Prev | Up | Next
Chapter 3. Selecting and Downloading the NVIDIA Packages for Your System | Home | Chapter 5. Listing of Installed Components